#include "mlp_c.h"


mlp_c_runtime::mlp_c_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) : mlp_runtime(ctx, lang, opts){
}


mlp_c_runtime::~mlp_c_runtime(){
}


void mlp_c_runtime::destroy(mlp_context *ctx){
	mlp_runtime::destroy(ctx) ;
}


mlp_library *mlp_c_runtime::load_library(mlp_context *ctx, const char *name, const void *opts){
	return new mlp_c_library(ctx, this, name, opts) ;
}


void mlp_c_runtime::setup_context(mlp_context *ctx){
    ctx->clear_error() ;
    CInvContext *data = cinv_context_create() ;
    if (data == NULL){
        ctx->set_error(MLP_LANGUAGE_ERROR, "Can't create cinvoke context") ;
        return ;
    }

    ctx->set_runtime_data(this, (const void *)data) ;
}


