#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "mlp_priv.h"


int mlp_do_debug(int level){
	const char *do_debug = getenv("MLP_DEBUG") ;
	if ((do_debug != NULL)&&(do_debug[0] != '\0')){
		int lvl = atoi(do_debug) ;
		if (level <= lvl){
			return 1 ;
		}
	}

	return 0 ;
}


void mlp_debug(int level, const char *fmt, ...){
	if (mlp_do_debug(level)){
		va_list va ;
		va_start(va, fmt) ;
		fprintf(stderr, "DEBUG: ", level) ;
		int i ;
		for (i = 0 ; i < level ; i++){
			fprintf(stderr, " ") ;
		}
		vfprintf(stderr, fmt, va) ;
		va_end(va) ;
		fprintf(stderr, "\n") ;
		fflush(stderr) ;
	}
}


void mlp_debug_value(const mlp_value *value, const char *fmt, ...){
	va_list va ;
	va_start(va, fmt) ;
	char name[1024] ;
	vsnprintf(name, 1023, fmt, va) ;
	va_end(va) ;

	if (value != NULL){
		switch (value->type){
			/*
			case MLP_UNKNOWN:
				mlp_debug(5, "Value %-10s:\tunknown\t(%p)", name, value->value.v) ;
				break ;
			*/
			case MLP_LONG:
				mlp_debug(5, "Value %-10s:\tlong\t(%ld)", name, value->value.l) ;
				break ;
			case MLP_DOUBLE:
				mlp_debug(5, "Value %-10s:\tdouble\t(%lf)", name, value->value.d) ;
				break ;
			case MLP_STRING:
				mlp_debug(5, "Value %-10s:\tstring\t(%s)", name, value->value.s) ;
				break ;
			default:
				mlp_debug(5, "Value %-10s:\tUNKNOWN TYPE %d!!!", name, value->type) ;
				break ;
		}
	}
	else {
		mlp_debug(5, "Value %-10s:\tNULL", name) ;
	}
}


