#include <stdlib.h>
#include "mlp_c.h"


char mlp_c_type2cinvformat(mlp_type t){
	switch (t){
		case MLP_INT:
			return 'i' ;
		case MLP_LONG:
			return 'l' ;
		case MLP_DOUBLE:
			return 'd' ;
		case MLP_STRING:
			return 'p' ;
	}
}


void *mlp_c_allocate_cinv_type(mlp_type t){
	switch (t){
		case MLP_INT:
			return malloc(sizeof(int)) ;
		case MLP_LONG:
			return malloc(sizeof(long)) ;
		case MLP_DOUBLE:
			return malloc(sizeof(double)) ;
		case MLP_STRING:
			return malloc(sizeof(char *)) ;
	}
}


void *mlp_c_allocate_cinv_value(mlp_type t, mlp_value *v){
	void *ptr = mlp_c_allocate_cinv_type(t) ;

	switch (t){
		case MLP_INT:
			((int *)ptr)[0] = mlp_value_to_int(v) ;
			break ;
		case MLP_LONG:
			((long *)ptr)[0] = mlp_value_to_long(v) ;
			break ;
		case MLP_DOUBLE:
			((double *)ptr)[0] = mlp_value_to_double(v) ;
			break ;
		case MLP_STRING:
			((const char **)ptr)[0] = mlp_value_to_string(v) ;
			break ;
	}

	return ptr ;
}


mlp_value *mlp_c_allocate_mlp_value(mlp_type t, void *ptr){
	switch (t){
		case MLP_INT:
			return mlp_value_new_from_int(*((int *)ptr)) ;
		case MLP_LONG:
			return mlp_value_new_from_long(*((long *)ptr)) ;
		case MLP_DOUBLE:
			return mlp_value_new_from_double(*((double *)ptr)) ;
		case MLP_STRING:
			return mlp_value_new_from_string(*((const char **)ptr)) ;
	}
}
