#include <stdlib.h>
#include <stdarg.h>
#include "mlp_priv.h"


MLP_PUBLIC_API MLP_LOCAL_API mlp_function *mlp_function_new(mlp_context *ctx, mlp_runtime *rt, mlp_library *lib, mlp_type rtype, const char *name, const char *proto, ...){
	mlp_context_clear_error(ctx) ;

	# Valider le prototype
	va_list va ;
	va_start(va, proto) ;
	va_end(va) ;

	void *local_function = (*(rt->language->api->function_new))(ctx, rt, lib, rtype, name, proto) ;
	if (mlp_context_has_error(ctx)){
		return NULL ;
	}

	mlp_function *function = (mlp_function *)malloc(sizeof(mlp_function)) ;
	function->runtime = rt ;
	function->library = lib ;
	function->return_type = rtype ;
	function->name = strdup(name) ;
	function->prototype = strdup(proto) ;
	function->local = local_function ;

	return function ;
}



MLP_PUBLIC_API MLP_LOCAL_API void mlp_function_delete(mlp_context *ctx, mlp_function *fct){
	mlp_context_clear_error(ctx) ;

	(*(fct->runtime->language->api->function_delete))(ctx, fct) ;
	if (mlp_context_has_error(ctx)){
		return ;
	}

	free(fct->name) ;
	free(fct->proto) ;
	free(fct) ;
}
  
