#include <stdlib.h>
#include <string.h>
#include "mlp_priv.h"


MLP_PUBLIC_API MLP_LOCAL_API mlp_library *mlp_library_new(mlp_context *ctx, mlp_runtime *rt, const char *name, const void *opts){
	mlp_context_clear_error(ctx) ;
	void *local_library = (*(rt->language->api->library_new))(ctx, rt, name, opts) ;
	if (mlp_context_has_error(ctx)){
		return NULL ;
	}

	mlp_library *library = (mlp_library *)malloc(sizeof(mlp_library)) ;
	library->runtime = rt ;
	library->name = strdup(name) ;
	library->local = local_library ;

	return library ;
}


MLP_PUBLIC_API MLP_LOCAL_API void mlp_library_delete(mlp_context *ctx, mlp_library *lib){
	mlp_context_clear_error(ctx) ;

	(*(lib->runtime->language->api->library_delete))(ctx, lib) ;
	if (mlp_context_has_error(ctx)){
		return ;
	}

	free(lib->name) ;
	free(lib) ;
}


MLP_PUBLIC_API const char *mlp_library_get_name(mlp_context *ctx, mlp_library *lib){
	mlp_context_clear_error(ctx) ;

	return lib->name ;
}


MLP_PUBLIC_API mlp_runtime *mlp_library_get_runtime(mlp_context *ctx, mlp_library *lib){
	mlp_context_clear_error(ctx) ;

	return lib->runtime ;
}
