/* mlp_p.h, generated on Thu Jun 26 14:42:29 2008 */

/* From context.c: */
mlp_context *mlp_context_new() ;
void mlp_context_delete(mlp_context *ctx) ;
mlp_error mlp_context_has_error(mlp_context *ctx) ;
mlp_error mlp_context_get_error(mlp_context *ctx) ;
const char *mlp_context_get_error_msg(mlp_context *ctx) ;
void mlp_context_set_error(mlp_context *ctx, mlp_error e, const char *fmt, ...) ;
void mlp_context_clear_error(mlp_context *ctx) ;

/* From value.c: */
mlp_value *mlp_value_new_from_long(long val) ;
mlp_value *mlp_value_new_from_int(int val) ;
mlp_value *mlp_value_new_from_double(double val) ;
mlp_value *mlp_value_new_from_string(const char *val) ;
void mlp_value_delete(mlp_value *v) ;
long mlp_value_to_long(mlp_value *v) ;
int mlp_value_to_int(mlp_value *v) ;
double mlp_value_to_double(mlp_value *v) ;
const char *mlp_value_to_string(mlp_value *v) ;
mlp_type mlp_value_get_type(mlp_value *v) ;

/* From language.c: */
mlp_language *mlp_language_init(mlp_context *ctx, const char *name) ;
void mlp_language_delete(mlp_context *ctx, mlp_language *lang) ;
const char *mlp_language_get_name(mlp_context *ctx, mlp_language *lang) ;

/* From runtime.c: */
mlp_runtime *mlp_runtime_new(mlp_context *ctx, mlp_language *lang, const void *opts) ;
void mlp_runtime_delete(mlp_context *ctx, mlp_runtime *rt) ;
void mlp_runtime_init_context(mlp_context *ctx, mlp_runtime *rt) ;

/* From library.c: */
mlp_library *mlp_library_new(mlp_context *ctx, mlp_runtime *rt, const char *name, const void *opts) ;
void mlp_library_delete(mlp_context *ctx, mlp_library *lib) ;
const char *mlp_library_get_name(mlp_context *ctx, mlp_library *lib) ;
mlp_runtime *mlp_library_get_runtime(mlp_context *ctx, mlp_library *lib) ;


