#ifndef _MLP_PRIV_H_
#define _MLP_PRIV_H_


#include "mlp.h"


#define MLP_MAX_ERROR_MSG_LENGTH    1024
#define MLP_MAX_RUNTIMES		    128


/* MLP Context */
struct _mlp_context {
	mlp_error err ;
	char *err_msg ;
	const void *runtime_data[MLP_MAX_RUNTIMES] ;
} ;


/* MLP Value */
struct _mlp_value {
	mlp_type t ;
	union {
		int i ;
		long l ;
		double d ;
		char *s ;
	} v ;
	char *stringy ;
} ;


#include "mlp_priv_p.h"


/* MLP Language */
struct _mlp_language {
	char *name ;
	void *handle ;

	mlp_local_api *api ;
} ;


/* MLP Runtime */
struct _mlp_runtime {
	mlp_language *language ;
	int id ;

	void *local ;
} ;


/* MLP Library */
struct _mlp_library {
	mlp_runtime *runtime ;
	char *name ;

	void *local ;
} ;


/* MLP Function */
struct _mlp_function {
	mlp_runtime *runtime ;
	mlp_library *library ;

	mlp_type return_type ;
	char *name ;
	char *prototype ;
	
	void *local ;
} ;




#endif
