/* mlp_priv_p.h, generated on Thu Jun 26 14:39:22 2008 */

/* From mlp.c: */
void mlp_debug(int level, const char *fmt, ...) ;

/* From context.c: */
void mlp_context_set_runtime_data(mlp_context *ctx, mlp_runtime *rt, const void *data) ;
void *mlp_context_get_runtime_data(mlp_context *ctx, mlp_runtime *rt) ;

/* From runtime.c: */
int mlp_runtime_get_id(mlp_runtime *rt) ;


struct _mlp_local_api {

	/* From runtime.c: */
	void *(*runtime_new)(mlp_context *ctx, mlp_language *lang, const void *opts) ;
	void (*runtime_delete)(mlp_context *ctx, mlp_runtime *rt) ;
	void (*runtime_init_context)(mlp_context *ctx, mlp_runtime *rt) ;

	/* From library.c: */
	void *(*library_new)(mlp_context *ctx, mlp_runtime *rt, const char *name, const void *opts) ;
	void (*library_delete)(mlp_context *ctx, mlp_library *lib) ;
} ;
typedef struct _mlp_local_api mlp_local_api ;


#define MLP_GENERATE_LOCAL_API(local, lang) \
	(mlp_local_api *)malloc(sizeof(mlp_local_api)) ; \
	\
	/* From runtime.c: */ \
	void *mlp_ ## lang ## _runtime_new(mlp_context *ctx, mlp_language *lang, const void *opts) ; \
	local->runtime_new = mlp_ ## lang ## _runtime_new ; \
	void mlp_ ## lang ## _runtime_delete(mlp_context *ctx, mlp_runtime *rt) ; \
	local->runtime_delete = mlp_ ## lang ## _runtime_delete ; \
	void mlp_ ## lang ## _runtime_init_context(mlp_context *ctx, mlp_runtime *rt) ; \
	local->runtime_init_context = mlp_ ## lang ## _runtime_init_context ; \
	\
	/* From library.c: */ \
	void *mlp_ ## lang ## _library_new(mlp_context *ctx, mlp_runtime *rt, const char *name, const void *opts) ; \
	local->library_new = mlp_ ## lang ## _library_new ; \
	void mlp_ ## lang ## _library_delete(mlp_context *ctx, mlp_library *lib) ; \
	local->library_delete = mlp_ ## lang ## _library_delete ; \


