plan_tests(18) ;

{
mlp_value *i = mlp_value_new_from_int(42) ;
ok(mlp_value_to_int(i) == 42, "Int value as int is 42") ;
ok(mlp_value_to_double(i) == (double)42, "Int value as double is 42.0") ;
ok(strcmp(mlp_value_to_string(i), "42") == 0, "Int value as string is \\"42\\"") ;
mlp_value_delete(i) ;
}

{
mlp_value *l = mlp_value_new_from_long(42L) ;
ok(mlp_value_to_long(l) == 42L, "Long value as long is 42") ;
ok(mlp_value_to_double(l) == (double)42L, "Long value as double is 42.0") ;
ok(strcmp(mlp_value_to_string(l), "42") == 0, "Long value as string is \\"42\\"") ;
mlp_value_delete(l) ;
}

{
mlp_value *d = mlp_value_new_from_double(42.6) ;
ok(mlp_value_to_double(d) == 42.6, "Double value as double is 42.6") ;
ok(mlp_value_to_long(d) == 42L, "Double value as long is 42") ;
ok(strncmp(mlp_value_to_string(d), "42.6", 4) == 0, "Double value as string is \\"42.6\\"", mlp_value_to_string(d)) ;
mlp_value_delete(d) ;
}

{
mlp_value *s = mlp_value_new_from_string("42.6") ;
ok(strcmp(mlp_value_to_string(s), "42.6") == 0, "String value as string is \\"42.6\\"") ;
ok(mlp_value_to_long(s) == 42L, "String value as long is 42") ;
ok(mlp_value_to_double(s) == 42.6, "String value as double is 42.6") ;
mlp_value_delete(s) ;
}


{
mlp_value *s = mlp_value_new_from_string("some string") ;
ok(strcmp(mlp_value_to_string(s), "some string") == 0, "String value as string is \\"some string\\"") ;
ok(mlp_value_to_long(s) == 0L, "String value as long is 0") ;
ok(mlp_value_to_double(s) == (double)0L, "String value as double is 0.0") ;
mlp_value_delete(s) ;
}


{
mlp_value *s = mlp_value_new_from_string((const char *)NULL) ;
ok(mlp_value_to_string(s) == NULL, "String value as string is NULL") ;
ok(mlp_value_to_long(s) == 0L, "String value as long is 0") ;
/* Here we test NANness by using x != x */
ok(mlp_value_to_double(s) != mlp_value_to_double(s), "String value as double is NAN") ;
}
