#!/bin/bash

MLP_TEST_LANG=${MLP_TEST_LANG:-c}
export LD_LIBRARY_PATH=../$MLP_TEST_LANG/.libs:$LD_LIBRARY_PATHA
echo LD_LIBRARY_PATH=$LD_LIBRARY_PATH

if [ -f $MLP_TEST_LANG/test.env ] ; then
	. $MLP_TEST_LANG/test.env
else
	echo "Can't locate $MLP_TEST_LANG/test.env" >&2
	exit 1
fi

export HARNESS_PERL="./test"

TESTS=$1
[ -z "$TESTS" ] && TESTS=$MLP_TEST_ONLY
[ -z "$TESTS" ] && TESTS=*.t

export MLP_TEST_UNDER_HARNESS=1
perl -e "use Test::Harness qw(&runtests \$verbose); \$verbose='$MLP_DEBUG'; runtests @ARGV;" $TESTS

