#include "mlp_haskell.h"
#include <stdlib.h>
#include <string.h>


mlp_haskell_runtime::mlp_haskell_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) : mlp_c_runtime(ctx, lang, opts){
	const char *argv[] = {"mlp_haskell", NULL} ;
	const char **argv_ = argv ;
	int argc = 1 ;
 
	hs_init(&argc, (char ***)&argv_) ;
}


mlp_haskell_runtime::~mlp_haskell_runtime(){
}


void mlp_haskell_runtime::destroy(mlp_context *ctx){
	hs_exit() ;
	mlp_c_runtime::destroy(ctx) ; 
}


mlp_library *mlp_haskell_runtime::load_library(mlp_context *ctx, const char *name, const void *opts){
	mlp_library *lib = mlp_c_runtime::load_library(ctx, name, opts) ;
	if (lib == NULL){
		return NULL ;
	}

	mlp_prototype proto ;
	mlp_arguments args ;
	char *buf = (char *)malloc((strlen(name) + 32) * sizeof(char)) ;
	sprintf(buf, "__stginit_%s", name) ;
	mlp_function *f = lib->get_function(ctx, MLP_INT, buf, proto) ;
	mlp_debug(2, "f=%p", f) ;
	f->call(ctx, args) ; 

	return lib ;
}
