#include "mlp_lua.h"


/* TODO: Error checking... */
mlp_lua_runtime::mlp_lua_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) 
	: mlp_runtime(ctx, lang, opts), my_lua(NULL){
    ctx->clear_error() ;

	my_lua = lua_alloc() ;
	lua_construct(my_lua) ;

	char *embedding[] = { "", "-e", "0" } ;
	lua_parse(my_lua, NULL, 3, embedding, NULL) ;
	PL_exit_flags |= PERL_EXIT_DESTRUCT_END ;

	lua_run(my_lua) ;
}


mlp_lua_runtime::~mlp_lua_runtime(){
	if (my_lua != NULL){
		lua_destruct(my_lua);
		lua_free(my_lua);
	}
}


PerlInterpreter *mlp_lua_runtime::_get_my_lua(){
	return my_lua ;
}


void mlp_lua_runtime::destroy(mlp_context *ctx){
    ctx->clear_error() ;
	mlp_runtime::destroy(ctx) ;
}


mlp_library *mlp_lua_runtime::load_library(mlp_context *ctx, const char *name, const void *opts){
    ctx->clear_error() ;
	return new mlp_lua_library(ctx, this, name, opts) ;
}


void mlp_lua_runtime::setup_context(mlp_context *ctx){
    ctx->clear_error() ;
}


