#ifndef _MLP_H_
#define _MLP_H_

#include <stdarg.h>


#define MLP_VERSION "0.01"


/* MLP error codes */
enum _mlp_error {
	MLP_NOT_SUPPORTED = -1000,  	/* Language does not support this feature */
	MLP_NOT_IMPLEMENTED = -1001, 	/* Language supports this feature but plugin doesn't implement it yet... */

	MLP_OK = 0,
	MLP_PLUGIN_ERROR,
	MLP_LANGUAGE_ERROR,
	MLP_LIBRARY_ERROR,
	MLP_RUNTIME_ERROR,
	MLP_FUNCTION_ERROR,

	MLP_NO_SUCH_FUNCTION,
	MLP_NO_SUCH_CLASS,
	MLP_INVALID_ARGUMENT,
	MLP_INVALID_RETURN_VALUE,
	MLP_INTERNAL_ERROR
} ;
typedef enum _mlp_error mlp_error ;


/* MLP supported data types */
enum _mlp_type {
	MLP_INT,
	MLP_LONG,
	MLP_DOUBLE,
	MLP_STRING,
	MLP_ARRAY,
	MLP_OBJECT
} ;
typedef enum _mlp_type mlp_type ;


struct _mlp_context ;
typedef struct _mlp_context mlp_context ;
struct _mlp_value ;
typedef struct _mlp_value mlp_value ;

struct _mlp_language ;
typedef struct _mlp_language mlp_language ;
struct _mlp_runtime ;
typedef struct _mlp_runtime mlp_runtime ;
struct _mlp_library ;
typedef struct _mlp_library mlp_library ;
struct _mlp_function ;
typedef struct _mlp_function mlp_function ;
struct _mlp_array ;
typedef struct _mlp_array mlp_array ;
struct _mlp_object ;
typedef struct _mlp_object mlp_object ;


#ifdef __cplusplus
	#define MLP_API extern "C"
#else
	#define MLP_API
#endif


#include "mlp.p"


#endif
