#include "mlp_impl.h"


mlp_language::mlp_language(mlp_language_impl *_impl): impl(impl){
}


mlp_language::~mlp_language(){
}


const char *mlp_language::get_name(mlp_context *ctx){
	ctx->clear_error() ;
	return impl->get_name(ctx) ; 
}
MLP_API const char *mlp_language_get_name(mlp_context *ctx, mlp_language *lang){
	lang->get_name(ctx) ;
}


bool mlp_language::destroy(mlp_context *ctx){
	ctx->clear_error() ;
	bool ret = impl->destroy(ctx) ;
	delete this ;
	return ret ;
}
MLP_API int mlp_language_destroy(mlp_context *ctx, mlp_language *lang){
	return lang->destroy(ctx) ;
}


mlp_language *mlp_language::init(mlp_context *ctx, const char *name){
	ctx->clear_error() ;
	mlp_language_impl *impl = mlp_language_impl::init(ctx, name) ;
	if (impl == NULL){
		return NULL ;
	}
	return new mlp_language(impl) ;
}
MLP_API mlp_language *mlp_language_init(mlp_context *ctx, const char *name){
	return mlp_language::init(ctx, name) ;
}


mlp_runtime *mlp_language::new_runtime(mlp_context *ctx, const void *opts){
	ctx->clear_error() ;
	mlp_runtime_impl *rt_impl = impl->new_runtime(ctx, opts) ;
	if (rt_impl == NULL){
		return NULL ;
	}
	return new mlp_runtime(rt_impl) ;
}
MLP_API mlp_runtime *mlp_language_new_runtime(mlp_context *ctx, mlp_language *lang, const void *opts){
	return lang->new_runtime(ctx, opts) ;
}
