#ifndef _MLP_IMPL_H_
#define _MLP_IMPL_H_


#include "mlp.h"


class mlp_language_impl ;
class mlp_runtime_impl ;


/* MLP Language */
class mlp_language_impl {
	std::string name ;
	static std::map<std::string, mlp_language_impl *> languages ;
	void *handle ;

	protected: 
		mlp_language_impl(const char *name) ;
		virtual ~mlp_language_impl() ;
	public: 
		static mlp_language_impl *init(mlp_context *ctx, const char *name) ;
		virtual mlp_runtime_impl *new_runtime(mlp_context *ctx, const void *opts) = 0 ;
		const char *get_name(mlp_context *ctx) ;
		bool destroy(mlp_context *ctx) ;
} ;


/* MLP Runtime */
class mlp_runtime_impl {
	mlp_language_impl *lang ;

	protected:
		mlp_runtime_impl(mlp_context *ctx, mlp_language_impl *lang, const void *opts) ;
		virtual ~mlp_runtime_impl() ;
/*
	public:
	virtual mlp_library *load_library(mlp_context *ctx, const char *name, const void *opts) = 0 ;
	virtual void setup_context(mlp_context *ctx) = 0 ;
	//virtual value *call_function(context *ctx, const char *name, int nb_args, const value **args) = 0 ;
	//virtual object *new_object(context *ctx, const clazz *cls, int nb_args, const value **args) = 0 ;
	//virtual mlp_array *new_array(mlp_context *ctx, mlp_type type, mlp_arguments *args) = 0 ;
	mlp_language *get_language(mlp_context *ctx) ;
	virtual void destroy(mlp_context *ctx) ;
*/
} ;


#endif
