/* Prototypes from mlp.cpp */
MLP_API void mlp_debug(int level, const char *fmt, ...) ;

/* Prototypes from context.cpp */
MLP_API mlp_context *mlp_context_new() ;
MLP_API void mlp_context_destroy(mlp_context *ctx) ;
MLP_API int mlp_context_has_error(mlp_context *ctx) ;
MLP_API mlp_error mlp_context_get_error(mlp_context *ctx) ;
MLP_API const char *mlp_context_get_error_msg(mlp_context *ctx) ;
MLP_API void mlp_context_set_verror(mlp_context *ctx, mlp_error e, const char *fmt, va_list va) ;
MLP_API void mlp_context_set_error(mlp_context *ctx, mlp_error e, const char *fmt, ...) ;
MLP_API void mlp_context_clear_error(mlp_context *ctx) ;
MLP_API void mlp_context_set_runtime_data(mlp_context *ctx, mlp_runtime *rt, const void *data) ;
MLP_API void mlp_context_get_runtime_data(mlp_context *ctx, mlp_runtime *rt) ;

/* Prototypes from value.cpp */
MLP_API mlp_value *mlp_value_new_from_int(int val) ;
MLP_API mlp_value *mlp_value_new_from_long(long val) ;
MLP_API mlp_value *mlp_value_new_from_double(double val) ;
MLP_API mlp_value *mlp_value_new_from_string(const char *val) ;
MLP_API mlp_value *mlp_value_new_from_array(mlp_array *val) ;
MLP_API mlp_value *mlp_value_new_from_object(mlp_object *val) ;
MLP_API void mlp_value_delete(mlp_value *val) ;
MLP_API mlp_type mlp_value_get_type(mlp_value *val) ;
MLP_API int mlp_value_to_int(mlp_value *val) ;
MLP_API long mlp_value_to_long(mlp_value *val) ;
MLP_API double mlp_value_to_double(mlp_value *val) ;
MLP_API const char *mlp_value_to_string(mlp_value *val) ;
MLP_API const mlp_object *mlp_value_to_object(mlp_value *val) ;

/* Prototypes from language.cpp */
MLP_API const char *mlp_language_get_name(mlp_context *ctx, mlp_language *lang) ;
MLP_API int mlp_language_destroy(mlp_context *ctx, mlp_language *lang) ;
MLP_API mlp_language *mlp_language_init(mlp_context *ctx, const char *name) ;
MLP_API mlp_runtime *mlp_language_new_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) ;

/* Prototypes from language_impl.cpp */

/* Prototypes from runtime.cpp */

