/********************************************************************** 
 * shapes.h -- sample code
 * @author  M. Samek
 * @version 1.00, 03/06/97
 */
#ifndef __SHAPES__

#include "object.h"
#include "string.h"

/** Interface Scaleable */
INTERFACE(Scaleable)
   void (*Scale)(Object, double); 
END_INTERFACE

/** Class Shape extends Object, implements Scaleable */
CLASS(Shape, Object) IMPLEMENTS(Scaleable);
   struct String name;     /* public shape's name */
VTABLE(Shape, Object) EXTENDS(Scaleable);
   double (*Area)(Shape);  /* pure virtual! */
METHODS
   Shape Shape_Con(Shape this, char *name);
   void Shape_Des(Shape this);
END_CLASS

/** Class Rect extends Shape */
CLASS(Rect, Shape)
   double __w; /* private width  */
   double __h; /* private height */
VTABLE(Rect, Shape)
METHODS
   Rect RectCon(Rect this, char *name, double w, double h);
   double RectArea(Rect this);
   void RectScale(Rect this, double mag);
END_CLASS

/** Class Circle extends Shape */
CLASS(Circle, Shape)
   double __r; /* private radius */
VTABLE(Circle, Shape)
METHODS
   Circle CircleCon(Circle this, char* name, double r);
   double CircleArea(Circle this);
   void CircleScale(Circle this, double mag);
END_CLASS

BEGIN_VTABLE(Shape, Object)
   VMETHOD(Object, Des) = (void (*)(Object))Shape_Des;
   VMETHOD(Shape, Area) = (double (*)(Shape))Object_NoIm;
   IMETHOD(Scaleable, Scale) = (void (*)(Object, double))Object_NoIm;
END_VTABLE

BEGIN_VTABLE(Rect, Shape)
   VMETHOD(Shape, Area) = (double (*)(Shape))RectArea;
   IMETHOD(super.Scaleable, Scale) = (void (*)(Object,
double))RectScale;
END_VTABLE

#define __SHAPES__
#endif

