plan_tests(10) ;

mlp_context ctx ;
ok(! ctx.has_error(), "Context doesn't have a pending error") ;
ok(ctx.get_error() == MLP_OK, "Context error is MLP_OK") ;
ok(ctx.get_error_msg() == NULL, "Context error msg is NULL") ;

ctx.set_error(MLP_INTERNAL_ERROR, NULL) ;
ok(ctx.get_error() == MLP_INTERNAL_ERROR, "Context error is MLP_INTERNAL_ERROR") ;
ok(ctx.get_error_msg() == NULL, "Context error msg is NULL") ;

ctx.clear_error() ;
ok(ctx.get_error() == MLP_OK, "Context error is MLP_OK") ;
ok(ctx.get_error_msg() == NULL, "Context error msg is NULL") ;

ctx.set_error(MLP_INTERNAL_ERROR, "internal %s", "error") ;
ok(ctx.get_error() == MLP_INTERNAL_ERROR, "Context error is MLP_INTERNAL_ERROR") ;
ok(strcmp(ctx.get_error_msg(), "internal error") == 0, "Context error msg is \\"internal error\\"") ;

mlp_runtime *rt = NULL ;
ctx.set_runtime_data(rt, (const void *)"data") ;
ok(strcmp((const char  *)ctx.get_runtime_data(rt), "data") == 0, "Context runtime data for NULL is \\"data\\"") ;
