plan_tests(18) ;

{
mlp_value i(42) ;
ok(i.to_int() == 42, "Int value as long is 42") ;
ok(i.to_double() == (double)42, "Int value as double is 42.0") ;
ok(strcmp(i.to_string(), "42") == 0, "Int value as string is \\"42\\"") ;
}

{
mlp_value l(42L) ;
ok(l.to_long() == 42L, "Long value as long is 42") ;
ok(l.to_double() == (double)42L, "Long value as double is 42.0") ;
ok(strcmp(l.to_string(), "42") == 0, "Long value as string is \\"42\\"") ;
}

{
mlp_value d(42.6) ;
ok(d.to_double() == 42.6, "Double value as double is 42.6") ;
ok(d.to_long() == 42L, "Double value as long is 42") ;
ok(strncmp(d.to_string(), "42.6", 4) == 0, "Double value as string is \\"42.6\\"", d.to_string()) ;
}

{
mlp_value s("42.6") ;
ok(strcmp(s.to_string(), "42.6") == 0, "String value as string is \\"42.6\\"") ;
ok(s.to_long() == 42L, "String value as long is 42") ;
ok(s.to_double() == 42.6, "String value as double is 42.6") ;
}


{
mlp_value s("some string") ;
ok(strcmp(s.to_string(), "some string") == 0, "String value as string is \\"some string\\"") ;
ok(s.to_long() == 0L, "String value as long is 0") ;
ok(s.to_double() == (double)0L, "String value as double is 0.0") ;
}


{
mlp_value s((const char *)NULL) ;
ok(s.to_string() == NULL, "String value as string is NULL") ;
ok(s.to_long() == 0L, "String value as long is 0") ;
// Here we test NANness by using x != x
ok(s.to_double() != s.to_double(), "String value as double is NAN") ;
}
