#ifndef _MLP_LUA_H_
#define _MLP_LUA_H_

#include "../src/mlp.h"
#include <lua.h>


class mlp_lua_language : public mlp_language {
	public:
	mlp_lua_language() ;
	virtual mlp_runtime *new_runtime(mlp_context *ctx, const void *opts) ;
} ;


class mlp_lua_runtime : public mlp_runtime {
	//PerlInterpreter *my_lua ;

	protected:
	virtual ~mlp_lua_runtime() ;
	public:
	mlp_lua_runtime(mlp_context *ctx, mlp_language *lang, const void *opts) ;
	virtual mlp_library *load_library(mlp_context *ctx, const char *name, const void *opts) ;
	virtual void setup_context(mlp_context *ctx) ;	
	// PerlInterpreter *_get_my_lua() ;
	virtual void destroy(mlp_context *ctx) ;
} ;


class mlp_lua_library : public mlp_library {

	protected:
	virtual ~mlp_lua_library() ;
	public:
	mlp_lua_library(mlp_context *ctx, mlp_runtime *rt, const char *name, const void *opts) ;
	virtual mlp_function *get_function(mlp_context *ctx,
		mlp_type rtype, const char *name, mlp_prototype proto) ;
	virtual void destroy(mlp_context *ctx) ;
} ;


class mlp_lua_function : public mlp_function {
	// CV *coderef ;

	protected:
	virtual ~mlp_lua_function() ;
	public:
	mlp_lua_function(mlp_context *ctx, mlp_runtime *rt, mlp_library *lib,
		mlp_type rtype, const char *name, mlp_prototype proto) ;
    virtual mlp_value *call(mlp_context *ctx, mlp_arguments args) ;
	virtual void destroy(mlp_context *ctx) ;
} ;


//SV *mlp_lua_allocate_SV(mlp_lua_runtime *rt, mlp_type t, mlp_value *v) ;
// mlp_value *mlp_lua_allocate_mlp_value(mlp_lua_runtime *rt, mlp_type t, SV *sv) ;


#endif
