#!/bin/bash

MLP_TEST_LANG=${MLP_TEST_LANG:-c}
export LD_LIBRARY_PATH=../$MLP_TEST_LANG/.libs:$LD_LIBRARY_PATHA
echo LD_LIBRARY_PATH=$LD_LIBRARY_PATH

if [ -f $MLP_TEST_LANG/test.env ] ; then
	. $MLP_TEST_LANG/test.env
else
	echo "Can't locate $MLP_TEST_LANG/test.env" >&2
	exit 1
fi

export HARNESS_PERL="./test"

TESTS=
if [ -n "$1" ] ; then
	echo "Using \$1 ($1) as test list"
	TESTS="$1"
elif [ -n "$MLP_TEST_ONLY" ] ; then
	echo "Using \$MLP_TEST_ONLY ($MLP_TEST_ONLY) as test list"
	TESTS="$MLP_TEST_ONLY"
else
	TESTS=*.t
fi

echo $MLP_TEST_LANG
export MLP_TEST_UNDER_HARNESS=1
perl -e "use Test::Harness qw(&runtests \$verbose); \$verbose='1'; runtests @ARGV;" $TESTS

