package mlp ;


public class MLPValue {
	private Object v ;
	private MLPType type ;


	public MLPValue(boolean b){
		type = MLPType.BOOL ;
		v = Boolean.valueOf(b) ;
	}

	public boolean getBool(){
		if (type == MLPType.BOOL){
			return (Boolean)v ;
		}
		throw new RuntimeException("Can't call getBool() on a MLPValue of type " + 
			type.getName()) ;
	}

	public MLPValue(long l){
		type = MLPType.LONG ;
		v = new Long(l) ;
	}

	public long getLong(){
		if (type == MLPType.LONG){
			return (Long)v ;
		}
		throw new RuntimeException("Can't call getLong() on a MLPValue of type " + 
			type.getName()) ;
	}

	public MLPValue(double d){
		type = MLPType.DOUBLE ;
		v = new Double(d) ;
	}

	public double getDouble(){
		if (type == MLPType.DOUBLE){
			return (Double)v ;
		}
		throw new RuntimeException("Can't call getDouble() on a MLPValue of type " + 
			type.getName()) ;
	}

	public MLPValue(char c){
		type = MLPType.CHAR ;
		v = new Character(c) ;
	}

	public char getChar(){
		if (type == MLPType.CHAR){
			return (Character)v ;
		}
		throw new RuntimeException("Can't call getChar() on a MLPValue of type " + 
			type.getName()) ;
	}

	public MLPValue(String s){
		type = MLPType.STRING ;
		v = s ;
	}

	public String getString(){
		if (type == MLPType.STRING){
			return (String)v ;
		}
		throw new RuntimeException("Can't call getString() on a MLPValue of type " + 
			type.getName()) ;
	}

	public MLPValue(MLPObject o){
		type = MLPType.OBJECT ;
		v = o ;
	}

	public MLPObject getObject(){
		if (type == MLPType.OBJECT){
			return (MLPObject)v ;
		}
		throw new RuntimeException("Can't call getObject() on a MLPValue of type " + 
			type.getName()) ;
	}


	public MLPValue(MLPException e){
		type = MLPType.EXCEPTION ;
		v = e ;
	}

	public MLPException getException(){
		if (type == MLPType.EXCEPTION){
			return (MLPException)v ;
		}
		throw new RuntimeException("Can't call getException() on a MLPValue of type " + 
			type.getName()) ;
	}


	public MLPType getType(){
		return type ; 
	}


	public int getTypeNo(){
		return type.getNo() ; 
	}
} ;


