#ifndef _MLP_JAVA_PRIV_H_
#define _MLP_JAVA_PRIV_H_

#include "../../lib/c/mlp_priv.h"

#include "jni.h"


struct _mlp_java_runtime {
	JavaVM *jvm ;

	jclass class ;
	jmethodID class_getName ;

	jclass throwable ;
	jmethodID throwable_getMessage ;

	jclass api ;
	jmethodID api_newObject ;
	jmethodID api_callMethod ;

	jclass value ;
	jmethodID value_getTypeNo ;
	jmethodID value_new_bool ;
	jmethodID value_new_long ;
	jmethodID value_new_double ;
	jmethodID value_new_char ;
	jmethodID value_new_string ;
	jmethodID value_new_object ;
	jmethodID value_getBool ;
	jmethodID value_getLong ;
	jmethodID value_getDouble ;
	jmethodID value_getChar ;
	jmethodID value_getString ;
	jmethodID value_getObject ;
	jmethodID value_getException ;

	jclass object ;
	jmethodID object_getClassName ;

	jclass java_object ;
	jmethodID java_object_getClassName ;
	jmethodID java_object_getObject ;
	jmethodID java_object_new ;

	jclass exception ;
	jmethodID exception_getMessage ;

	jclass java_exception ;
	jmethodID java_exception_getMessage ;
	jmethodID java_exception_getValue ;
} ;
typedef struct _mlp_java_runtime mlp_java_runtime ;


JNIEnv *get_env(mlp_context *ctx, mlp_java_runtime *jrt) ;
char process_exception(mlp_context *ctx, mlp_java_runtime *jrt, JNIEnv *env, mlp_error err, const char *fmt, ...) ;

jclass load_class(mlp_context *ctx, JNIEnv *env, const char *class) ;
jmethodID get_method(mlp_context *ctx, JNIEnv *env, const char *cname, jclass class, const char *name, const char *proto) ;
jmethodID get_static_method(mlp_context *ctx, JNIEnv *env, const char *cname, jclass class, const char *name, const char *proto) ;
jstring jstring_new(mlp_context *ctx, JNIEnv *env, const char *s) ;
void jstring_delete(JNIEnv *env, jstring s) ; 

jobject java_MLPValue_new(mlp_context *ctx, mlp_runtime *rt, JNIEnv *env, mlp_value *v) ;
jobjectArray java_MLPValue_array_new(mlp_context *ctx, mlp_runtime *rt, JNIEnv *env, mlp_value **args, int nb_args) ;
void java_MLPValue_array_delete(JNIEnv *env, jobjectArray vargs, int nb_args) ;
mlp_value *mlp_value_new(mlp_context *ctx, mlp_runtime *rt, JNIEnv *env, jobject v) ;
jobject java_MLPJavaObject_new(mlp_context *ctx, mlp_runtime *rt, JNIEnv *env, mlp_object *obj) ;


#endif
