#include <stdlib.h>
#include <string.h>
#include "mlp_perl_priv.h"


void *_mlp_perl_runtime_new(mlp_context *ctx, mlp_language *lang){
    PerlInterpreter *my_perl = NULL ;
    char *embedding[] = { "", "-e", "0" } ;

    my_perl = perl_alloc() ;
    perl_construct(my_perl) ;
    perl_parse(my_perl, NULL, 3, embedding, NULL) ;
    PL_exit_flags |= PERL_EXIT_DESTRUCT_END ;
    perl_run(my_perl) ;

    return my_perl ;
}


void _mlp_perl_runtime_load_library(mlp_context *ctx, mlp_runtime *rt, const char *lib){
	PerlInterpreter *my_perl = (PerlInterpreter *)rt->handle ;

	int len = strlen(lib) ;
	char *buf = (char *)malloc((len + 32) * sizeof(char)) ;
	sprintf(buf, "use %s ;", lib) ;

	eval_pv(buf, FALSE) ;
	if (SvTRUE(ERRSV)){
		STRLEN n_a ;
		mlp_context_set_error(ctx, MLP_LIBRARY_ERROR, "Can't load library %s: %s\n",
			lib, SvPV(ERRSV, n_a)) ;
		free(buf) ;
		return ;
	}

	mlp_debug(2, "Perl module %s loaded", lib) ;
	free(buf) ;
}


void _mlp_perl_runtime_delete(mlp_context *ctx, mlp_runtime *rt){
	mlp_debug(3, "-> Perl runtime delete") ;
    PerlInterpreter *my_perl = (PerlInterpreter *)rt->handle ;

    perl_destruct(my_perl) ;
    perl_free(my_perl) ;
	mlp_debug(3, "<- Perl runtime delete") ;
}
