#include <stdlib.h>
#include <string.h>
#include "mlp_perl_priv.h"


SV *perl_SV_new(mlp_context *ctx, mlp_runtime *rt, mlp_value *v){
	PerlInterpreter *my_perl = (PerlInterpreter *)rt->handle ;

	mlp_type type = mlp_value_get_type(v) ;
	mlp_debug(4, "%i", type) ;
	SV *sv = NULL ;
    switch(type){
		case MLP_BOOL:
			sv = newSViv(mlp_value_get_bool(v)) ;
			break ;
		case MLP_LONG:
			sv = newSViv(mlp_value_get_long(v)) ;
			break ;
		case MLP_DOUBLE: {
			double d = mlp_value_get_double(v) ;
			mlp_debug(4, "d=%lf", d) ;
			sv = newSVnv(d) ;
			mlp_debug(4, "sv=%p", sv) ;
			break ;
		}
		case MLP_CHAR: {
			char c = mlp_value_get_char(v) ;
			char buf[8] ;
			sprintf(buf, "%c", c) ;
			sv = newSVpv(buf, 0) ;
			break ;
		}
 		case MLP_STRING:
			sv = newSVpv(mlp_value_get_string(v), 0) ;
			break ;
        case MLP_OBJECT: {
			/* 
            mlp_object *o = mlp_value_get_object(v) ;
            mlp_debug(1, "o=%s", mlp_object_to_string(o)) ;
            jobject jo = java_MLPJavaObject_new(ctx, rt, env, o) ;
            RETURN_NULL_IF_NULL(jo) ;
            vo = (*env)->NewObject(env, jrt->value, jrt->value_new_object, jo) ;
			*/
            break ;
        }
    }

	return sv ;
}

