#!/bin/bash
echo "/* This file was generated automatically on $(/bin/date) */"
echo
echo "struct _mlp_interface {"
cat mlp_api.h | while read tag rtype func args ; do
	if [ "$tag" = "MLP_IFACE_V" ] ; then
		rtype='void*'
		tag=MLP_IFACE
	fi
	if [ "$tag" = "MLP_IFACE" ] ; then
		name=${func#mlp_}
		echo "    $rtype (*$name)$args"
	fi
done
echo "} ;"
echo 


echo "#define MLP_INIT_IFACE(iface, lang) \\"
echo "    (mlp_interface *)malloc(sizeof(mlp_interface)) ; \\"
cat mlp_api.h | while read tag rtype func args ; do
	if [ "$tag" = "MLP_IFACE_V" ] ; then
		rtype='void*'
		tag=MLP_IFACE
	fi
	if [ "$tag" = "MLP_IFACE" ] ; then
		name=${func#mlp_}
		echo "    $rtype _mlp_ ## lang ## _$name$args \\"
		echo "    iface->$name = _mlp_ ## lang ## _$name ; \\"
	fi
done
echo 

