#ifndef _MLP_H_
#define _MLP_H_


#define MLP_VERSION "0.01"


/* Error codes */
enum _mlp_error {
	MLP_NOT_SUPPORTED = -1000,  /* Language does not support this feature */
	MLP_NOT_IMPLEMENTED= -1001, /* Language supports this feature but plugin doesn't implement it yet... */

    MLP_OK = 0,
    MLP_INTERNAL_ERROR,
    MLP_RUNTIME_ERROR,
    MLP_LIBRARY_ERROR,
} ;
typedef enum _mlp_error mlp_error ;


/* Data types */
enum _mlp_type {
	MLP_BOOL,
	MLP_LONG,
	MLP_DOUBLE,
	MLP_CHAR,
	MLP_STRING,
	MLP_OBJECT,
	MLP_ARRAY,
	MLP_EXCEPTION,
} ;
typedef enum _mlp_type mlp_type ;


/* Other types, all opaque... */
struct _mlp_context ;
typedef struct _mlp_context mlp_context ;
struct _mlp_value ;
typedef struct _mlp_value mlp_value ;

struct _mlp_language ;
typedef struct _mlp_language mlp_language ;
struct _mlp_runtime ;
typedef struct _mlp_runtime mlp_runtime ;
struct _mlp_library ;
typedef struct _mlp_library mlp_library ;
struct _mlp_object ;
typedef struct _mlp_object mlp_object ;
struct _mlp_array ;
typedef struct _mlp_array mlp_array ;
struct _mlp_exception ;
typedef struct _mlp_exception mlp_exception ;


/* Public API */
#include "mlp_api.h"


#endif

