import qualified MLP
import qualified MLP.Error
import qualified MLP.Context
import qualified MLP.Language
import qualified MLP.Runtime
import qualified MLP.Value
import qualified MLP.Object


main = do
  MLP.Context.withNew $ \ctx -> do					-- create a context
    MLP.Language.withNew ctx "perl" $ \lang -> do	-- init a language, i.e. perl
      rt <- MLP.Runtime.new ctx lang				-- create a runtime for the language
      MLP.Runtime.loadLibrary ctx rt "calc"			-- load a library, i.e. calc.pm
      val <- MLP.Object.new ctx rt "calc" [] ""		-- create a calc object, i.e. my $obj = new calc() ;
      obj <- MLP.Value.takeObject val				-- extract the object from the value
      MLP.Object.toString obj >>= putStrLn
      MLP.Value.delete ctx val

      MLP.Value.withValues ctx [MLP.Value.newLong 2, MLP.Value.newLong 3] $ \args -> do
        val <- MLP.Object.callMethod ctx obj "add" args ""
        MLP.Value.getLong val >>= putStrLn . show >> MLP.Value.delete ctx val

      MLP.Value.withValues ctx [MLP.Value.newDouble 3.5, MLP.Value.newDouble 4.6] $ \args -> do
        val <- MLP.Object.callMethod ctx obj "mul" args ""
        MLP.Value.getDouble val >>= putStrLn . show >> MLP.Value.delete ctx val

      MLP.Object.delete ctx obj
      MLP.Runtime.delete ctx rt
