#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"


#include <mlp_priv.h>


MODULE = MLP::Context		PACKAGE = MLP::Context
PROTOTYPES: ENABLE

mlp_context *
new(CLASS)
	CODE:
		RETVAL = mlp_context_new() ;
	OUTPUT:
		RETVAL


void 
delete(this)
	mlp_context *this
	PREINIT:
		this = NULL ;
	CODE:
		mlp_context_delete(this) ;


int
has_error(this)
	mlp_context *this
	PREINIT:
		this = NULL ;
	CODE:
		RETVAL = mlp_context_has_error(this) ;
	OUTPUT:
		RETVAL


mlp_error 
get_error(this)
	mlp_context *this
	PREINIT:
		this = NULL ;
	CODE:
		RETVAL = mlp_context_get_error(this) ;
	OUTPUT:
		RETVAL


const char *
get_error_msg(this)
	mlp_context *this 
	PREINIT:
		this = NULL ;
	CODE:
		RETVAL = mlp_context_get_error_msg(this) ;
	OUTPUT:
		RETVAL


void
set_error(this, err, msg)
	mlp_context *this
	mlp_error err
	const char *msg
	PREINIT:
		this = NULL ;
		fprintf(stderr, "[%s]\n", msg) ;
	CODE:
		mlp_context_set_error(this, err, "%s", msg) ;


void
clear_error(this)
	mlp_context *this
	PREINIT:
		this = NULL ;
	CODE:
		mlp_context_clear_error(this) ;


