#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dlfcn.h>
#include <stdarg.h>

#include "mlp.h"



int mlp_has_error(mlp_context *ctx){
	return (ctx->error == NULL ? 0 : 1) ;
}


void mlp_clear_error(mlp_context *ctx){
	if (ctx->error != NULL){
		free(ctx->error) ;
		ctx->error = NULL ;
	}
}


char *mlp_get_error(mlp_context *ctx){
	return ctx->error ;
}


void mlp_set_error(mlp_context *ctx, const char *fmt, ...){
	va_list va ;
	va_start(va, fmt) ;

	char *buf = (char *)malloc(1024 * sizeof(char)) ;
	vsnprintf(buf, 1023, fmt, va) ;

	mlp_clear_error(ctx) ;
	ctx->error = buf ;
}


char *mlp_get_class(mlp_object *obj){
	return obj->class ;
}
