#include <string.h>
#include <stdio.h>
#include <tap.h>
#include <mlp.h>


void mlp_debug(mlp_context *ctx){
	fprintf(stderr, "%s\n", mlp_get_error(ctx)) ;
}


int main(int argc, char **argv){
	plan_tests(2) ; 

	mlp_context *ctx ;
	mlp_interpreter *interp = mlp_create_interpreter("java", &ctx) ;
	if (interp == NULL){
		mlp_debug(ctx) ;
	}
	ok(interp != NULL, "interpreter initialized: %s", mlp_get_error(ctx)) ;
	ok(ctx != NULL, "context initialized") ;

	mlp_load_module(ctx, "mlp.test.Calculator") ;
	mlp_value args[2] ;
	args[0].type = MLP_LONG ;
	args[0].value.l = 2 ;
	args[1].type = MLP_LONG ;
	args[1].value.l = 3 ;
	mlp_value *sum = mlp_call_function(ctx, MLP_LONG, "mlp.test.Calculator", "add", args) ;

	return 0 ;
}
