#include <string.h>
#include <stdio.h>
#include <tap.h>
#include <mlp.h>


void mlp_debug(mlp_context *ctx){
	if (mlp_has_error(ctx)){
		fprintf(stderr, "%s\n", mlp_get_error(ctx)) ;
	}
}


int main(int argc, char **argv){
	plan_tests(4) ; 

	mlp_context *ctx = NULL ;
	mlp_interpreter *interp = mlp_create_interpreter("c", &ctx) ;
	mlp_debug(ctx) ;
	ok(interp != NULL, "interpreter initialized") ;
	ok(ctx != NULL, "context initialized") ;

	mlp_module *mod = mlp_load_module(ctx, "calc") ;
	mlp_debug(ctx) ;
	ok(mod != NULL, "module loaded") ;

	mlp_value args[2] ;
	args[0].type = MLP_LONG ;
	args[0].value.l = 2 ;
	args[1].type = MLP_LONG ;
	args[1].value.l = 3 ;
	mlp_value *sum = mlp_call_function(ctx, mod, MLP_LONG, NULL, "add", 2, args) ;
	ok(sum->value.l == 5, "add worked") ;

	return 0 ;
}
