#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "../src/mlp_priv.h"
#include "mlp_perl_priv.h"


mlp_value *_mlp_perl_convert_value(mlp_context *ctx, mlp_value *value, mlp_type type){
        return value ;
}


SV *mlp_perl_make_SV(mlp_context *ctx, const mlp_value *value){
	PerlInterpreter *my_perl = mlp_context_get_runtime(ctx)->runtime ;

	if (value == NULL){
		return &PL_sv_undef ;
	}

	mlp_type type = value->type ;
	switch (type){
		case MLP_LONG:
			return newSViv(value->value.l) ;
			break ;
		case MLP_DOUBLE:
			return newSVnv(value->value.d) ;
			break ;
		case MLP_STRING:
			return newSVpv(value->value.s, 0) ;
			break ;
		default:
			mlp_context_set_error(ctx, MLP_NOT_IMPLEMENTED, "perl_make_SV from %d", type) ;
			return NULL ;
	}
}

