#!/bin/bash


declare -a env_dirs
for d in ../* ; do
	lang=$(basename $d)
	if [ -f "$d/.libs/libmlp_$lang.so" ] ; then
		env_dirs=(${env_dirs[@]} "$d:$d/.libs:$lang:$lang/.libs")
	fi
done


function add_env_dir {
	local env=$1

	val=${env_dirs[@]}
	val=${val// /:}
	if [ -n "${!env}" ] ; then
		eval "$env=\$$env:$val"
	else
		eval "$env=$val"
	fi

	echo "$env=${!env}"
	export "$env"
}



export HARNESS_PERL="./test"
add_env_dir LD_LIBRARY_PATH
add_env_dir PERL5LIB
add_env_dir CLASSPATH

TESTS=${MLP_TEST_ONLY:-*.t}

export MLP_TEST_UNDER_HARNESS=1
perl -e "use Test::Harness qw(&runtests \$verbose); \$verbose='$MLP_DEBUG'; runtests @ARGV;" $TESTS

