plan_tests(4) ;

mlp_context *ctx = mlp_context_new() ;

mlp_language *lang = mlp_language_init(ctx, MLP_TEST_LANG) ; /* MLP_TEST_OPTS */ 
MLP_CHECK_ERROR(ctx, 3){
	ok(lang != NULL, "Language %s initialized", MLP_TEST_LANG) ;
	const char *name = mlp_language_get_name(lang) ;
	ok(strcmp(MLP_TEST_LANG, name) == 0, "Language name is %s", name) ;
	const char *dir = mlp_language_get_dir(lang) ;
	ok(dir != NULL, "Language directory is %s", dir) ;
}

mlp_language_delete(ctx, lang) ;
MLP_CHECK_ERROR(ctx, 1){
	pass("Language %s destroyed", MLP_TEST_LANG) ;
}

mlp_context_delete(ctx) ;
