#!/bin/bash

echo
export MLP_TEST_LANG=${MLP_TEST_LANG:-c}
export MLP_TEST_OPTS=${MLP_TEST_OPTS:-}
LD_LIBRARY_PATH=../lang/$MLP_TEST_LANG/.libs:$LD_LIBRARY_PATH

if [ -f $MLP_TEST_LANG/test.env ] ; then
	. $MLP_TEST_LANG/test.env
else
	echo "Can't locate $MLP_TEST_LANG/test.env" >&2
	exit 1
fi

export LD_LIBRARY_PATH
echo LD_LIBRARY_PATH="$LD_LIBRARY_PATH"
export HARNESS_PERL="./test"

TESTS=
if [ -n "$1" ] ; then
	echo "Using \$1 ($1) as test list"
	TESTS="$1"
elif [ -n "$MLP_TEST_ONLY" ] ; then
	echo "Using \$MLP_TEST_ONLY ($MLP_TEST_ONLY) as test list"
	TESTS="$MLP_TEST_ONLY"
else
	TESTS=*.t
fi

export MLP_TEST_UNDER_HARNESS=1
perl -e "use Test::Harness qw(&runtests \$verbose); \$verbose='1'; runtests @ARGV;" $TESTS

