package Ugly::Backend ;

use strict ;


my $REFERENCE_INDEX = 0 ;
my %REFERENCES = () ;


my %BACKEND_DISPATCH = (
	load_library => \&load_library,
) ;


sub backend {
	my $function = shift ;
	my @args = @_ ;

	my $code = $BACKEND_DISPATCH{$function} ;
	die("UGLY: Unknown backend function '$function'\n") unless defined($code) ;
	my $ret = $code->(@args) ;
}


sub load_library {
	my $file = shift ;

	require $file ;
	return 1 ;
}


sub call_function {
	my $function = shift ;
	my @args = @_ ;

	my $code = &{$function} ;
	my $ret = $code->(@args) ;
	$ret = register_ref($ret) if ref($ret) ;
	return $ret ;
}


sub register_ref {
	my $ref = shift ;
	$REFERENCES{$REFERENCE_INDEX++} = $ref ;
	return $REFERENCE_INDEX ;
}
